# coding: utf-8

"""
    Tator REST API

    Interface to the Tator backend.  # noqa: E501

    The version of the OpenAPI document: v1
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from ..configuration import Configuration


class ConcatDefinition(object):
    """
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'id': 'int',
        'num_frames': 'int'
    }

    attribute_map = {
        'id': 'id',
        'num_frames': 'numFrames'
    }

    def __init__(self, id=None, num_frames=None, local_vars_configuration=None):  # noqa: E501
        """ConcatDefinition - a model defined in OpenAPI"""
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._id = None
        self._num_frames = None
        self.discriminator = None

        if id is not None:
            self.id = id
        if num_frames is not None:
            self.num_frames = num_frames

    @property
    def id(self):
        """
        Primary key of video in append series

        :return: The id of this ConcatDefinition. 
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """
        Primary key of video in append series

        :param id: The id of this ConcatDefinition.
        :type: int
        """

        self._id = id

    @property
    def num_frames(self):
        """
        Number of frames to load from this video

        :return: The num_frames of this ConcatDefinition. 
        :rtype: int
        """
        return self._num_frames

    @num_frames.setter
    def num_frames(self, num_frames):
        """
        Number of frames to load from this video

        :param num_frames: The num_frames of this ConcatDefinition.
        :type: int
        """

        self._num_frames = num_frames

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ConcatDefinition):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ConcatDefinition):
            return True

        return self.to_dict() != other.to_dict()
